<?php

/**
 * conceptos_asignacion actions.
 *
 * @package    nomina
 * @subpackage conceptos_asignacion
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class conceptos_asignacionActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'NO_CONCEP_AB',
        'NO_CONCEP_NOMINA'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'NO_CONCEP_NOMINA' =>
        array(
            'id_concep_nomina' => 'NO_CONCEP_AB'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'NO_CONCEP_AB' =>
        array(
            'id_concep_ab' => 'id_concep_ab',
            'id_concep_nomina' => 'id_concep_nomina',
            'rango_minimo' => 'rango_minimo',
            'rango_maximo' => 'rango_maximo',
            'valor_fijo' => 'valor_fijo',
            'porcentaje' => 'porcentaje',
            'horas' => 'horas',
            'estado' => 'estado'
        ),
        'NO_CONCEP_NOMINA' =>
        array(
            'codigo' => 'codigo_concepto',
            'descripcion' => 'descripcion_concepto',
            'codigo,||, - ,||,descripcion' => 'completo_concepto'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'NO_CONCEP_AB' => array(
            'id_concep_ab,a' => array('!=' => array(-1)),
            'id_concep_ab,b' => array('=' => array('id_concep_ab')),
            'id_concep_nomina' => array('=' => array('id_concep_nomina')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
    protected $fields_orderBy = array(
        'id_concep_nomina'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;


    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_concep_ab'; //identificador de la tabla
    protected $id_names = array('id_concep_ab'); //llave primaria
    protected $field_names = array('id_concep_nomina', 'rango_minimo', 'rango_maximo', 'valor_fijo', 'porcentaje', 'horas', 'estado'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'NO_CONCEP_AB'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_concep_ab'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {


            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {

                //sentencia sql
                $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
                //ejecuta y obtiene el resultado del sql
                CN_TABLE::executeSQL($sql);

                $id_concep_ab = $list_data_post[0]['id_concep_ab'];
                $id_concep_nomina = $list_data_post[0]['id_concep_nomina'];

                $rango_minimo = $list_data_post[0]['rango_minimo'];
                $rango_maximo = $list_data_post[0]['rango_maximo'];
                $valor_fijo = $list_data_post[0]['valor_fijo'];

                $sql = <<<EOD
SELECT * FROM NO_PERIODO WHERE estado = 1 and activo = 1 
EOD;
                $results = CN_TABLE::executeSQL($sql);

                $id_anhos = $results[0]['id_anhos'];
                $id_meses = $results[0]['id_meses'];
                $id_periodo = $results[0]['id_periodo'];
                $id_tipo_periodo = $results[0]['id_tipo_periodo'];
                $fecha_desde = $results[0]['fecha_ini'];
                $fecha_hasta = $results[0]['fecha_fin'];

                $sql = <<<EOD
            SELECT * FROM NO_TIPO_PERIODO WHERE ID_TIPO_PERIODO = $id_tipo_periodo 
EOD;
                $results = CN_TABLE::executeSQL($sql);

                $num_dias = $results[0]['no_dias_mes'];
                $num_dias_val = $num_dias;

                /*
                 * Se realiza validacion con el nombramiento de personas activas - 20150116
                 */
                $sql = <<<EOD
select 
tab0.*
from no_concepto_func tab0 

join no_nombramiento_v tab1
on tab1.id_tipo_doc = tab0.id_tipo_doc
and tab1.num_doc = tab0.num_doc

where tab0.id_concep_nomina = 1 
and tab0.actual = 1 and tab0.estado = 1
and nvl(tab1.fecha_termina,(select no_periodo.fecha_ini from no_periodo 
        where id_periodo = $id_periodo)) >= (select no_periodo.fecha_ini from no_periodo 
        where id_periodo = $id_periodo) 
EOD;
//                $sql = "select *
//
//                from no_concepto_func tab0 
//
//            where tab0.id_concep_nomina = 1 and tab0.actual = 1 and tab0.estado = 1";

                $records = CN_TABLE::executeSQL($sql);

                foreach ($records as $funciona) {

                    $logger->info("Entre a ciclo - " . $id_concep_nomina);

                    $id_tipo_doc = $funciona['id_tipo_doc'];
                    $num_doc = $funciona['num_doc'];
                    $asignacion_basica = $funciona['valor'];

                    //Diferente a 1011 - 20220420::LAVILA
                    if ($id_concep_nomina != 11) {
                        if ($asignacion_basica >= $rango_minimo && $asignacion_basica <= $rango_maximo) {
                            /**
                             * Activa o actualiza el concepto segun el nuevo valor
                             */
                            $logger->info("Entre a validacion - ");

                            $sql = "select *

                from no_concepto_func tab0 

            where tab0.id_concep_nomina = $id_concep_nomina and tab0.actual = 1 and tab0.estado = 1 and tab0.id_tipo_doc = $id_tipo_doc and tab0.num_doc = $num_doc";

                            $records = CN_TABLE::executeSQL($sql);

                            if (count($records) > 0) {

                                $sql = "update no_concepto_func tab0 set tab0.valor = $valor_fijo

            where tab0.id_concep_nomina = $id_concep_nomina and tab0.actual = 1 and tab0.estado = 1 and tab0.id_tipo_doc = $id_tipo_doc and tab0.num_doc = $num_doc";

                                $this->conn->execute($sql);

                                $sql = "update NO_CONCEPTO_PERIODO tab0 set tab0.valor = $valor_fijo

            where tab0.id_concep_nomina = $id_concep_nomina and tab0.periodo=$id_periodo and tab0.id_tipo_doc = $id_tipo_doc and tab0.num_doc = $num_doc";

                                $this->conn->execute($sql);
                            } else {

                                $sql = <<<EOD
            INSERT INTO NO_CONCEPTO_FUNC (ID_TIPO_DOC,NUM_DOC,ID_CONCEP_NOMINA,VALOR,ESTADO,ACTUAL,FECHA_DESDE)
                VALUES($id_tipo_doc,$num_doc,$id_concep_nomina,$valor_fijo,1,1,to_date('$id_anhos-$id_meses-01','YYYY-MM-DD'))
EOD;
                                $this->conn->execute($sql);

                                /**
                                 * Valida que en el periodo actual tome los dias que corersponden segun 1001 - 20150604
                                 */
                                $sql = <<<EOD
select 
min(fecha_desde) as fecha_desde,
max(fecha_hasta) as fecha_hasta,
sum(num_dias) as num_dias
from no_concepto_periodo
where 
num_doc = $num_doc
and periodo = $id_periodo
and id_concep_nomina = 1 
EOD;

                                $records_val = CN_TABLE::executeSQL($sql);

                                if (count($records_val)) {

                                    $fecha_desde = $records_val[0]['fecha_desde'];
                                    $fecha_hasta = $records_val[0]['fecha_hasta'];
                                    $num_dias_val = $records_val[0]['num_dias'];

                                    if ($num_dias_val > $num_dias) {
                                        $num_dias_val = $num_dias;
                                    }
                                }

                                $sql = <<<EOD
INSERT INTO NO_CONCEPTO_PERIODO (ID_ANHOS,ID_MESES,PERIODO,ID_TIPO_DOC,NUM_DOC,ID_CONCEP_NOMINA,FECHA_DESDE,FECHA_HASTA,VALOR,NUM_DIAS)
    VALUES($id_anhos,$id_meses,$id_periodo,$id_tipo_doc,$num_doc,$id_concep_nomina,
        to_date('$fecha_desde','YYYY-MM-DD'), to_date('$fecha_hasta','YYYY-MM-DD'),
            $valor_fijo, $num_dias_val ) 
EOD;
                                $this->conn->execute($sql);
                            }
                        } else {
                            /**
                             * Inactiva conceptos
                             */
                            $sql = "select *

                from no_concepto_func tab0 

            where tab0.id_concep_nomina = $id_concep_nomina and tab0.actual = 1 and tab0.estado = 1 and tab0.id_tipo_doc = $id_tipo_doc and tab0.num_doc = $num_doc";

                            $records = CN_TABLE::executeSQL($sql);

                            if (count($records) > 0) {

                                $sql = "update no_concepto_func tab0 set tab0.valor = 0, tab0.estado = 0, tab0.actual = 0

            where tab0.id_concep_nomina = $id_concep_nomina and tab0.actual = 1 and tab0.estado = 1 and tab0.id_tipo_doc = $id_tipo_doc and tab0.num_doc = $num_doc";

                                $this->conn->execute($sql);

                                $sql = "update NO_CONCEPTO_PERIODO tab0 set tab0.valor = 0, tab0.num_dias = 0

            where tab0.id_concep_nomina = $id_concep_nomina and tab0.periodo=$id_periodo and tab0.id_tipo_doc = $id_tipo_doc and tab0.num_doc = $num_doc";

                                $this->conn->execute($sql);
                            }
                        }
                    }//fin if 1011
                }


                //COMMIT DE TODAS LAS TRANSACCIONES
                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
